'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gitToplevel = require('git-toplevel');

var _gitToplevel2 = _interopRequireDefault(_gitToplevel);

var _homedir = require('homedir');

var _homedir2 = _interopRequireDefault(_homedir);

var _pathExists = require('path-exists');

var _pathExists2 = _interopRequireDefault(_pathExists);

var _requireAll = require('require-all');

var _requireAll2 = _interopRequireDefault(_requireAll);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const COMMANDS_PATH = '.kd/commands';
const extend = Object.assign.bind(null, {});

exports.default = () => {
  return resolvePaths().then(paths => {
    return extend(req(paths.global), req(paths.user), req(paths.local));
  });
};

const req = dirname => {
  if (!_pathExists2.default.sync(dirname)) {
    return {};
  }

  return (0, _requireAll2.default)({
    dirname,
    resolve: cmd => cmd.default ? cmd.default : cmd
  });
};

const projectDir = () => {
  return new Promise(resolve => {
    return (0, _gitToplevel2.default)().then(resolve).catch(err => resolve(null));
  });
};

const resolvePaths = () => {
  return Promise.all([projectDir(), Promise.resolve((0, _homedir2.default)()), Promise.resolve(__dirname)]).then(([project, home, globals]) => {
    let paths = {
      user: _path2.default.join(home, COMMANDS_PATH),
      global: _path2.default.join(globals, 'commands')
    };

    if (project) {
      paths.local = _path2.default.join(project, COMMANDS_PATH);
    }

    return paths;
  });
};